#include <stdio.h>

#define NCHARS	(2048 + 125)	// else (125) fastAVRlink crash !!!

int main(void)
{
	FILE *f;
	int offset = NCHARS + 0x52 + 4 + 7;
	int checksum = 0;
	int i, j;
	int block_size;

	f = fopen("test.92s", "wb");
	if(f == NULL)
	{
		fprintf(stderr, "File open error.\n");
		return -1;
	}

/* header */

	fprintf(f, "**TI92**");
	fputc(0x01, f);
	fputc(0x00, f);
	fprintf(f, "main");
	for(i=0; i<4; i++)
		fputc(0, f);
	for(i=0; i<40; i++)
		fputc('x', f);
	fputc(0x01, f);
	fputc(0x00, f);
	fputc(0x52,f);
	fputc(0x00, f);
	fputc(0x00, f);
	fputc(0x00, f);
	fprintf(f, "test");
	for(i=0; i<4; i++)
		fputc(0, f);
	fputc(0x0c, f);
	fputc(0x00, f);
	fputc(0x00, f);
	fputc(0x00, f);
	fputc(offset & 0x000000ff, f);
	fputc((offset & 0x0000ff00) >> 8, f);
	fputc((offset & 0x00ff0000) >> 16, f);
	fputc((offset & 0xff000000) >> 24, f);
	fputc(0xA5, f);
	fputc(0x5A, f);

/* data part */
	for(i=0; i<4; i++)
		fputc(0x00, f);

	block_size = NCHARS + 5 - 2;

	fputc((block_size & 0xff00) >> 8, f);
	checksum += ((block_size & 0x00ff) >> 8);

	fputc((block_size & 0x00ff)	   , f);
	checksum += (block_size & 0x00ff);

	fputc(0x00, f);

	for(i=0; i < NCHARS; i++)
	{
		j = i % 256;
		checksum += j;
		fputc(j, f);
	}

	fputc(0x00, f);
	fputc(0x2d, f);
	checksum += 0x2d;

/* checksum */

	checksum += 0x10; //why ??
	fputc(checksum & 0xff, f);
	fputc((checksum & 0xff00) >> 8, f);

	fclose(f);

	return 0;
}